//mixer.h:

/*
 *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2012-2013
 *
 *  This file is part of SavannahIce,
 *  a protocol converter between RoarAudio and Icecast.
 *  See README for details.
 *
 *  This file is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 3
 *  as published by the Free Software Foundation.
 *
 *  RoarAudio is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this software; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301, USA.
 *
 */

#ifndef _SAVABBAHICE_MIXER_H_
#define _SAVABBAHICE_MIXER_H_

typedef struct savannahice_mixer * savannahice_mixer_t;

savannahice_mixer_t savannahice_mixer_new(void);
savannahice_mixer_t savannahice_mixer_new_simple(const char * node, uint16_t port, const char * mount, const char * user, const char * password);
int savannahice_mixer_set_node(savannahice_mixer_t self, const char * node, uint16_t port);
int savannahice_mixer_set_mount(savannahice_mixer_t self, const char * mount);
int savannahice_mixer_set_auth(savannahice_mixer_t self, const char * user, const char * password);
int savannahice_mixer_ref(savannahice_mixer_t self);
int savannahice_mixer_unref(savannahice_mixer_t self);

int savannahice_mixer_connect(savannahice_mixer_t self);
int savannahice_mixer_handle(savannahice_mixer_t self);

int savannahice_mixer_attach_stream(savannahice_mixer_t self, savannahice_stream_t stream);

int savannahice_mixer_set_codec(savannahice_mixer_t self, uint32_t codec);

// delay how long the caller should wait before calling savannahice_mixer_handle() again.
// time in us.
int_least32_t savannahice_mixer_delay(savannahice_mixer_t self);

savannahice_stream_t savannahice_mixer_stream(savannahice_mixer_t self);

#endif

//ll
