//network.h:

/*
 *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2012-2013
 *
 *  This file is part of SavannahIce,
 *  a protocol converter between RoarAudio and Icecast.
 *  See README for details.
 *
 *  This file is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 3
 *  as published by the Free Software Foundation.
 *
 *  RoarAudio is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this software; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301, USA.
 *
 */

#ifndef _SAVABBAHICE_NETWORK_H_
#define _SAVABBAHICE_NETWORK_H_

#ifndef DEFAULT_SERVER_TYPE
#define DEFAULT_SERVER_TYPE    ROAR_SOCKET_TYPE_UNKNOWN
#endif

#define DEFAULT_UNIX_ADDRESS "/tmp/SavannahIce"

typedef struct savannahice_network * savannahice_network_t;

savannahice_network_t savannahice_network_new(void);
int savannahice_network_ref(savannahice_network_t self);
int savannahice_network_unref(savannahice_network_t self);

int savannahice_network_add_listen_address(savannahice_network_t self, int type, const char * address, int port, int proto);
int savannahice_network_add_client_fh(savannahice_network_t self, int fh, int proto);
int savannahice_network_add_protocol(savannahice_network_t self, const savannahice_protocol_t * proto);

int savannahice_network_del_listen_all(savannahice_network_t self);

int savannahice_network_check(savannahice_network_t self, int_least32_t timeout);

int savannahice_network_client_get_userdata(savannahice_network_t self, int clientid, void *** userdata);

#endif

//ll
