//stream.h:

/*
 *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2012-2013
 *
 *  This file is part of SavannahIce,
 *  a protocol converter between RoarAudio and Icecast.
 *  See README for details.
 *
 *  This file is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 3
 *  as published by the Free Software Foundation.
 *
 *  RoarAudio is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this software; see the file COPYING.  If not, write to
 *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301, USA.
 *
 */

#ifndef _SAVABBAHICE_STREAM_H_
#define _SAVABBAHICE_STREAM_H_

typedef struct savannahice_stream * savannahice_stream_t;

int savannahice_stream_init(void);
int savannahice_stream_free(void);

savannahice_stream_t savannahice_stream_new(int client, int dir, uint32_t codec);
int savannahice_stream_ref(savannahice_stream_t self);
int savannahice_stream_unref(savannahice_stream_t self);

int savannahice_stream_get_id(savannahice_stream_t self);
int savannahice_stream_get_client(savannahice_stream_t self);
int savannahice_stream_get_dir(savannahice_stream_t self);
int savannahice_stream_get_status(savannahice_stream_t self);
uint32_t savannahice_stream_get_codec(savannahice_stream_t self);

int savannahice_stream_set_status(savannahice_stream_t self, const int status);

int savannahice_stream_add_buffer(savannahice_stream_t self, struct roar_buffer * buffer);
struct roar_buffer ** savannahice_stream_get_buffer(savannahice_stream_t self);
ssize_t savannahice_stream_get_bufferspace(savannahice_stream_t self);

int savannahice_stream_get_alone(savannahice_stream_t self);

#endif

//ll
